#!/usr/bin/env python3

# Copyright (C) 2024, UChicago Argonne, LLC
# Licensed under the 3-clause BSD license.  See accompanying LICENSE.txt file
# in the top-level directory.

import numpy as np


def search_before_and_after(df, filt, before=0, after=0):
    """given a dataframe and filter expression, return the lines before and after."""
    filt_lst = []
    for i in range(before):
        filt_lst.append(filt.shift(-(i + 1), fill_value=False))
    filt_lst.append(filt)
    for i in range(after):
        filt_lst.append(filt.shift(i + 1, fill_value=False))
    df2 = df[np.logical_or.reduce(filt_lst)]
    return df2
